Summary: An X Window System based IBM 3278/3279 terminal emulator.
Name: x3270
Version: 3.2.16
Release: 4
License: MIT
Group: Applications/Internet
URL: http://www.geocities.com/SiliconValley/Peaks/7814
Source0: %{url}/downloads.html/x3270-3216.tgz
Source1: %{url}/downloads.html/tcl3270-3216.tgz
Source2: %{url}/downloads.html/c3270-3216.tgz
# included but not compiled
Source3: %{url}/downloads.html/s3270-3216.tgz
Patch0: x3270-3.2.16-redhat.patch
Prereq:  %{_prefix}/X11R6/bin/mkfontdir
BuildPreReq: tcl ncurses-devel readline-devel glibc-devel
BuildRoot: %{_tmppath}/%{name}-root

%package x11
Summary: IBM 3278/3279 terminal emulator for the X Window System.
Group: Applications/Internet
Requires: %{name} = %{version}

%package text
Summary: IBM 3278/3279 terminal emulator for text mode.
Group: Applications/Internet
Requires: %{name} = %{version}

%package tcl
Summary: IBM 3278/3279 terminal emulator TCL bindings.
Group: Applications/Internet
Requires: %{name} = %{version}

%description
The x3270 package contains files needed for emulating the IBM 3278/3279
terminals, commonly used with mainframe applications.

You will also need to install a frontend for %{name}. Available frontends
are %{name}-x11 (for the X Window System), %{name}-text (for text mode) and
%{name}-tcl (for Tcl scripting).

%description x11
The x3270 program opens a window in the X Window System which emulates
the actual look of an IBM 3278/3279 terminal, commonly used with
mainframe applications.  x3270 also allows you to telnet to an IBM
host from the x3270 window.

Install the %{name}-x11 package if you need to access IBM hosts using an IBM
3278/3279 terminal emulator from X11.

%description text
The c3270 program opens a 3270 terminal which emulates the actual look of an
IBM 3278/3279 terminal, commonly used with mainframe applications.
x3270 also allows you to telnet to an IBM host from the x3270 window.

Install the %{name}-text package if you need to access IBM hosts using an IBM
3278/3279 terminal emulator without running X.

%description tcl
The tcl3270 program opens a 3270 terminal which emulates the actual look of an
IBM 3278/3279 terminal, commonly used with mainframe applications.
x3270 also allows you to telnet to an IBM host from the x3270 window using
a tcl script to control the session.

Install the %{name}-tcl package if you need to access IBM hosts using an IBM
3278/3279 terminal emulator using Tcl scripting.

%prep
%setup -q -n x3270-3.2 -a 1 -a 2
%patch0 -p1 -b .rh

%build
export PATH=$PATH:/usr/X11R6/bin
export CFLAGS="$RPM_OPT_FLAGS" CXXFLAGS="$RPM_OPT_FLAGS"
# Set LIBX3270DIR to something we can share with x3270-nox
perl -pi -e "s,LIBX3270DIR =.*,LIBX3270DIR = /usr/lib/x3270,g" Imakefile.in
%configure --enable-app-defaults --prefix=/usr/X11R6
xmkmf -a
make
cd tcl3270-3.2
%configure --prefix=/usr/X11R6
make
cd ../c3270-3.2
%configure --prefix=/usr
make

%install
export PATH=$PATH:/usr/X11R6/bin
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%{_prefix}/bin
mkdir -p $RPM_BUILD_ROOT%{_prefix}/lib/x3270
mkdir -p $RPM_BUILD_ROOT%{_mandir}/man1
mkdir -p ${RPM_BUILD_ROOT}%{_prefix}/X11R6/bin
mkdir -p ${RPM_BUILD_ROOT}%{_prefix}/X11R6/man/man1
mkdir -p ${RPM_BUILD_ROOT}%{_prefix}/X11R6/lib/X11/fonts/misc
mkdir -p ${RPM_BUILD_ROOT}%{_prefix}/X11R6/lib/X11/app-defaults

# XXX Hack around mkfontdir madness on install.
install -m755 x3270 $RPM_BUILD_ROOT%{_prefix}/X11R6/bin
install -m755 x3270if $RPM_BUILD_ROOT%{_prefix}/X11R6/bin
install -m644 *pcf.gz $RPM_BUILD_ROOT%{_prefix}/X11R6/lib/X11/fonts/misc
install -m644 X3270.ad $RPM_BUILD_ROOT%{_prefix}/X11R6/lib/X11/app-defaults/X3270
install -m644 ibm_hosts $RPM_BUILD_ROOT%{_prefix}/lib/x3270
for i in x3270 x3270if x3270-script ibm_hosts; do
	install -m644 $i.man $RPM_BUILD_ROOT%{_prefix}/X11R6/man/man1/$i.1x
done
install -m755 pr3287/pr3287 $RPM_BUILD_ROOT%{_prefix}/X11R6/bin
install -m644 pr3287/pr3287.man $RPM_BUILD_ROOT%{_prefix}/X11R6/man/man1/pr3287.1x
cd tcl3270-3.2
install -m755 tcl3270 $RPM_BUILD_ROOT%{_prefix}/X11R6/bin
install -m644 tcl3270.man $RPM_BUILD_ROOT%{_mandir}/man1
cd ../c3270-3.2
install -m755 c3270 $RPM_BUILD_ROOT%{_prefix}/bin
install -m755 x3270if $RPM_BUILD_ROOT%{_prefix}/bin
install -m755 pr3287/pr3287 $RPM_BUILD_ROOT%{_prefix}/bin
for i in c3270 x3270if x3270-script ibm_hosts; do
    install -m644 $i.man $RPM_BUILD_ROOT%{_mandir}/man1/$i.1
done
cd ..

install -m644 X3270.xad ${RPM_BUILD_ROOT}%{_prefix}/X11R6/lib/X11/app-defaults/X3270

( cd $RPM_BUILD_ROOT
  mkdir -p .%{_sysconfdir}/X11/applnk/Utilities
  cat > .%{_sysconfdir}/X11/applnk/Utilities/x3270.desktop <<EOF
[Desktop Entry]
Name=x3270
Type=Application
Comment=3270 terminal emulator
Exec=x3270
EOF
)

rm -f Examples/*.rh
chmod -x Examples/*
mv $RPM_BUILD_ROOT%{_mandir}/man1/tcl3270.man $RPM_BUILD_ROOT%{_mandir}/man1/tcl3270.1
for i in pr3287 x3270if; do
	mv $RPM_BUILD_ROOT/usr/X11R6/bin/$i $RPM_BUILD_ROOT/usr/bin
	ln -s ../../bin/$i $RPM_BUILD_ROOT/usr/X11R6/bin
done

%clean
rm -rf $RPM_BUILD_ROOT

%post x11
cd %{_prefix}/X11R6/lib/X11/fonts/misc && %{_prefix}/X11R6/bin/mkfontdir

%postun x11
if [ "$1" = "0" ]; then
  cd %{_prefix}/X11R6/lib/X11/fonts/misc && %{_prefix}/X11R6/bin/mkfontdir
fi

%files
%defattr(-,root,root)
%doc README Examples html
%{_prefix}/bin/pr3287
%{_prefix}/bin/x3270if
%{_mandir}/man1/ibm_hosts*
%{_mandir}/man1/x32*
%dir %{_prefix}/lib/x3270
%config(noreplace) %{_prefix}/lib/x3270/ibm_hosts

%files x11
%defattr(-,root,root)
%{_prefix}/X11R6/bin/x3270
%{_prefix}/X11R6/bin/pr3287
%{_prefix}/X11R6/bin/x3270if
%{_prefix}/X11R6/lib/X11/fonts/misc/3270*
%{_prefix}/X11R6/man/man1/*
%config(missingok) %{_sysconfdir}/X11/applnk/Utilities/x3270.desktop
%config %{_prefix}/X11R6/lib/X11/app-defaults/X3270

%files text
%defattr(-,root,root)
%{_prefix}/bin/c3270
%{_mandir}/man1/c3270*

%files tcl
%defattr(-,root,root)
%{_prefix}/X11R6/bin/tcl3270
%{_mandir}/man1/tcl3270*

%changelog
* Mon Jul 16 2001 Bernhard Rosenkraenzer <bero@redhat.com> 3.2.16-4
- Add build dependencies (#48930)

* Sat Jun 09 2001 Florian La Roche <Florian.LaRoche@redhat.de>
- remove all provides/requires for x3270-frontend

* Sun May 13 2001 Bernhard Rosenkraenzer <bero@redhat.com> 3.2.16-2
- Rebuild with new readline

* Thu May 10 2001 Bernhard Rosenkraenzer <bero@redhat.com> 3.2.16-1
- 3.2.16
- adapt patches
- get rid of the **** pdksh requirement
- split the tcl version into a different package, no need to require tcl for
  normal use
- split the x11 frontend into a separate package.
  We don't necessarily have X on a machine where we want to run
  3270 sessions (e.g. s390...)

* Fri Dec 22 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- 3.2.14
- Add c3270 (textmode x3270) in x3270-text package
- Fix build
- Make ibm_hosts a %config(noreplace)

* Tue Oct 24 2000 Jeff Johnson <jbj@redhat.com>
- remove /usr/local paths in Examples.

* Sun Oct 22 2000 Jeff Johnson <jbj@redhat.com>
- update to 3.2.13.

* Thu Jul 13 2000 Prospector <bugzilla@redhat.com>
- automatic rebuild

* Fri Jun  2 2000 Jeff Johnson <jbj@redhat.com>
- rebuild for 7.0

* Mon Feb 07 2000 Preston Brown <pbrown@redhat.com>
- wmconfig -> desktop

* Mon Feb  7 2000 Jeff Johnson <jbj@redhat.com>
- compress man pages.

* Fri Jan 14 2000 Jeff Johnson <jbj@redhat.com>
- update to 3.1.1.9 (see URL for pending 3.2alpha version).

* Fri Sep 24 1999 Preston Brown <pbrown@redhat.com>
- change to directory before doing a mkfontdir

* Sun Mar 21 1999 Cristian Gafton <gafton@redhat.com> 
- auto rebuild in the new build environment (release 7)

* Tue Jan 12 1999 Jeff Johnson <jbj@redhat.com>
- ibm_hosts needed %config (#788)

* Fri Aug  7 1998 Jeff Johnson <jbj@redhat.com>
- build root

* Fri May 01 1998 Prospector System <bugs@redhat.com>
- translations modified for de, fr, tr

* Wed Oct 22 1997 Marc Ewing <marc@redhat.com>
- new version
- added wmconfig entry

* Mon Jul 21 1997 Erik Troan <ewt@redhat.com>
- built against glibc
